signature TestTheory =
sig
  type thm = Thm.thm
  
  (*  Definitions  *)
    val SUITE : thm
    val TEST : thm
    val TEST_TY_DEF : thm
    val TEST_case_def : thm
    val TEST_repfns : thm
    val TEST_size_def : thm
    val Test0_def : thm
    val Test1_def : thm
  
  (*  Theorems  *)
    val TEST_11 : thm
    val TEST_Axiom : thm
    val TEST_case_cong : thm
    val TEST_distinct : thm
    val TEST_induction : thm
    val TEST_nchotomy : thm
  
  val Test_grammars : type_grammar.grammar * term_grammar.grammar
(*
   [L0] Parent theory of "Test"
   
   [SUITE]  Definition
      
      |- SUITE = Test1
   
   [TEST]  Definition
      
      |- TEST = Test0
   
   [TEST_TY_DEF]  Definition
      
      |- ?rep.
           TYPE_DEFINITION
             (\a0.
                !'TEST'.
                  (!a0.
                     (?a. a0 = (\a. CONSTR 0 a (\n. BOTTOM)) a) \/
                     (?a.
                        (a0 =
                         (\a.
                            CONSTR (SUC 0) (@v. T) (FCONS a (\n. BOTTOM)))
                           a) /\ 'TEST' a) ==>
                     'TEST' a0) ==>
                  'TEST' a0) rep
   
   [TEST_case_def]  Definition
      
      |- (!f f1 a. case f f1 (TEST a) = f a) /\
         !f f1 a. case f f1 (SUITE a) = f1 a
   
   [TEST_repfns]  Definition
      
      |- (!a. mk_TEST (dest_TEST a) = a) /\
         !r.
           (\a0.
              !'TEST'.
                (!a0.
                   (?a. a0 = (\a. CONSTR 0 a (\n. BOTTOM)) a) \/
                   (?a.
                      (a0 =
                       (\a. CONSTR (SUC 0) (@v. T) (FCONS a (\n. BOTTOM)))
                         a) /\ 'TEST' a) ==>
                   'TEST' a0) ==>
                'TEST' a0) r =
           (dest_TEST (mk_TEST r) = r)
   
   [TEST_size_def]  Definition
      
      |- (!a. TEST_size (TEST a) = 1) /\
         !a. TEST_size (SUITE a) = 1 + TEST_size a
   
   [Test0_def]  Definition
      
      |- Test0 = (\a. mk_TEST ((\a. CONSTR 0 a (\n. BOTTOM)) a))
   
   [Test1_def]  Definition
      
      |- Test1 =
         (\a.
            mk_TEST
              ((\a. CONSTR (SUC 0) (@v. T) (FCONS a (\n. BOTTOM)))
                 (dest_TEST a)))
   
   [TEST_11]  Theorem
      
      |- (!a a'. (TEST a = TEST a') = (a = a')) /\
         !a a'. (SUITE a = SUITE a') = (a = a')
   
   [TEST_Axiom]  Theorem
      
      |- !f0 f1.
           ?fn. (!a. fn (TEST a) = f0 a) /\ !a. fn (SUITE a) = f1 a (fn a)
   
   [TEST_case_cong]  Theorem
      
      |- !M M' f f1.
           (M = M') /\ (!a. (M' = TEST a) ==> (f a = f' a)) /\
           (!a. (M' = SUITE a) ==> (f1 a = f1' a)) ==>
           (case f f1 M = case f' f1' M')
   
   [TEST_distinct]  Theorem
      
      |- !a' a. ~(TEST a = SUITE a')
   
   [TEST_induction]  Theorem
      
      |- !P. (!I. P (TEST I)) /\ (!T. P T ==> P (SUITE T)) ==> !T. P T
   
   [TEST_nchotomy]  Theorem
      
      |- !T. (?I. T = TEST I) \/ ?T'. T = SUITE T'
   
   
*)
end
