(* =============================================================

   the signature of a test-engine (the thing that is used
   to run a test-suite)

============================================================= *)
signature Test_Engine =
   sig

   local

   open Parse HolKernel 
   open PP
   open Test_emb_mldata 

   in

   type TEoption   

   val option    : TEoption ref 

   val teAlg     : (string -> ppstream -> unit) alg_TEST_   
                   (* the string is a the 'name-path' in the TEST structure,
                      from root to the current node *)

   (* pretty printer for building the complete te *)
   val ppte : (ppstream -> unit) (* the pp of the test-suite body *)
              ->  ppstream -> unit

   end 
end 