(* ===================================================================

  This file provides:

  (1) ML data-type TEST to represent test-suites

  (2) The coresponding algebra-type and fold for TEST

  author: wishnu prasetya

=================================================================== *)

local

open Parse HolKernel
open Susp 

in 

datatype ('instr,'term) TEST = 

             TEST   of { tlabel : string
                       , tbody  : 'instr 
                       , tself  : 'term susp }

          | SUITE  of { slabel : string
                      , sset   : (('instr,'term) TEST) list 
                      , sself  : 'term susp }
 

type ('instr,'result,'term) alg_TEST =

     { ftest  : 'term susp -> string -> 'instr -> 'result

     , fsuite : 'term susp -> string -> 'result list -> 'result

    }

fun fold_TEST

    (alg : ('instr,'result,'term) alg_TEST)

    (t : ('instr,'term) TEST)

     =  
     let
     fun worker (TEST t)  = (#ftest alg)  (#tself t) 
                                          (#tlabel t) 
                                          (#tbody t)

       | worker (SUITE t) = (#fsuite alg) (#sself t)
                                          (#slabel t)
                                          (List.map worker (#sset t))
     in
     worker t
     end

(* ===================================================================

  A concrete instance of TEST and alg_TEST

=================================================================== *)    

type TEST_       = (term,term) TEST
type 'r alg_TEST_   = (term,'r,term) alg_TEST

end