(* =============================================================

   the signature of a translator

============================================================= *)
signature Translator =
   sig

   local

   open Parse HolKernel 
   open L0_emb_mldata PP

   in

   type Toption  (* the state to keep Translator's options *)

   val option    : Toption ref 

   (* for translating fractions of L0 which are still left unspecified 
      by L0 syntax           *)

   val translate_expr          : term -> ppstream -> unit
   val translate_assertion     : term -> ppstream -> unit
   val translate_assertion_ret : term -> ppstream -> unit

   val tAlgebra  : (ppstream -> unit) alg_INSTR_               

  (* for translating the entire program structure *)

  val translate_prog : term  (* prog-name *)
                       -> term list -> term list -> term list (* the parameters *)
                       -> hol_type (* the return type *)
                       -> (ppstream -> unit) (* pp of the body *) 
                       -> ppstream 
                       -> unit

   end 
end 

